// This file is automatically generated by Make.bash.
// Any changes made to this file will be lost.
package cynosurex.library.TetherProxLibrary;
import cynosurex.application.TetherProx.R;

import android.graphics.Point;

import java.util.HashMap;
import java.util.Map;

/** ParsedURL. This class is NOT thread-safe. */
public class ParsedURL implements URLConstants {
  private final Map<Part, Point> parts;
  private final StringBuilder urlChars;

  public ParsedURL(char[] c, Map<Part, Point> parts) {
    this.urlChars = new StringBuilder();
    this.urlChars.append(c);
    this.parts = parts;
  }

  public ParsedURL(StringBuilder urlChars, Map<Part, Point> parts) {
    this.urlChars = urlChars;
    this.parts = parts;
  }

  public StringBuilder getChars() {
    return urlChars;
  }

  public String getString(Part part) {
    Point p = parts.get(part);
    if (p == null) return null;

    return urlChars.substring(p.x, p.y);
  }

  public Point getRange(Part part) {
    return parts.get(part);
  }

  public int getLength(Part part) {
    Point p = parts.get(part);
    if (p == null) return -1;
    return p.y - p.x;
  }

  public String getHost() {
    return getString(Part.HOST);
  }

  public String getPath() {
    return getString(Part.PATH);
  }

  public String getQuery() {
    return getString(Part.QUERY);
  }

  public String getRef() {
    return getString(Part.REF);
  }

  public String getProtocol() {
    return getString(Part.PROTOCOL);
  }

  public String getPort() {
    return getString(Part.PORT);
  }

  public String getUser() {
    return getString(Part.USER);
  }

  public String getPassword() {
    return getString(Part.PASSWORD);
  }

  public void set(Part p, String s) {
    if (s == null) return;
    int diff = s.length();
    Point existing = parts.get(p);
    if (existing == null) {
      int x = getInsertionPointBefore(p);
      parts.put(p, new Point(x, x + s.length()));
      urlChars.insert(x, s);
    } else {
      urlChars.replace((int) existing.x, (int) existing.y, s);
      diff = s.length() - ((int) existing.y - (int) existing.x);
      existing.x = (existing.x);
      existing.y = existing.x + s.length();
    }
    boolean after = false;
    for (Part part : Part.getOrder()) {
      if (after) {
        Point point = parts.get(part);
        if (point != null) {
          point.x = point.x + diff;
          point.y = point.y + diff;
        }
      } else if (part == p) {
        after = true;
      }
    }
  }

  public void remove(Part p) {
    Point pt = parts.remove(p);
    if (pt != null) {
      urlChars.delete((int) pt.x, (int) pt.y);
    }
  }

  public void lowerCase(URLConstants.Part... parts) {
    for (URLConstants.Part part : parts) {
      Point p = getRange(part);
      for (int i = p.x; i < p.y; ++i) {
        urlChars.setCharAt(i, Character.toLowerCase(urlChars.charAt(i)));
      }
    }
//    String lchost = host.toLowerCase();
//    if (!lchost.equals(host)) {
//      int idx = sb.indexOf(host);
//      sb.replace(idx, idx + host.length(), lchost);
//    }
  }

  public int getInsertionPointBefore(Part before) {
    Point point = null;
    for (Part part : Part.getOrder()) {
      if (part == before) {
        break;
      }
      Point p = parts.get(part);
      if (p != null) {
        point = p;
      }
    }
    return point == null ? -1 : point.y;
  }

  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append(getProtocol()).append("://");
    if (parts.containsKey(Part.USER)) {
      sb.append(getUser());
      if (parts.containsKey(Part.PASSWORD)) {
        sb.append(":").append(getPassword());
      }
      sb.append("@");
    }
    sb.append(getHost());
    if (parts.containsKey(Part.PORT)) sb.append(":").append(getPort());
    if (parts.containsKey(Part.PATH)) sb.append(getPath());
    if (parts.containsKey(Part.REF)) sb.append("#").append(getRef());
    if (parts.containsKey(Part.QUERY)) sb.append("?").append(getQuery());
    return sb.toString();
  }

  public ParsedURL newInstance() {
    Map<Part, Point> m = new HashMap<Part, Point>();
    for (Map.Entry<Part, Point> entry : parts.entrySet()) {
      m.put(entry.getKey(), new Point(entry.getValue()));
    }
    return new ParsedURL(new StringBuilder(urlChars), m);
  }
}
