// This file is automatically generated by Make.bash.
// Any changes made to this file will be lost.
package cynosurex.library.TetherProxLibrary;
import cynosurex.application.TetherProx.R;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLDecoder;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class URLUtils {
  private static transient Logger logger = Logger.getLogger(URLUtils.class.getName());
  public static int CONNECT_TIMEOUT_MILLISECONDS = 10000;
  public static int READ_TIMEOUT_MILLISECONDS = 30000;
  private static final Pattern REGEX_NAIVE_DOMAIN = Pattern.compile("^(?:.*?\\.)?(.*?)\\.(ne|ac|biz|co|com|edu|gov|info|mil|net|org|us)$", Pattern.CASE_INSENSITIVE);
  private static final Pattern REGEX_COUNTRY_TLD = Pattern.compile("\\.(ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gd|ge|gf|gg|gh|gi|gl|gm|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kr|kw|ky|kz|la|lc|li|lk|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sk|sl|sm|sn|sr|st|su|sv|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tr|tt|tv|tw|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|ws|ye|yu|za|zm|zw)$", Pattern.CASE_INSENSITIVE);

  public static String addProtocol(String host) {
    return !host.startsWith("http") ? "http://" + host : host;
  }

  public static boolean sameHost(String source, String url) {
    if (source == null) return true;
    try {
      String srcHost = getHost(source);
      String urlHost = getHost(url);
      return srcHost.equalsIgnoreCase(urlHost);
    } catch (Throwable t) {
      return false;
    }
  }

  public static boolean sameParent(String source, String url) {
    if (source == null) return true;
    try {
      ParsedURL sourceParsed = URLParser.parse(source);
      ParsedURL urlParsed = URLParser.parse(url);
      if (!sourceParsed.getHost().equalsIgnoreCase(urlParsed.getHost())) return false;

      String srcPath = sourceParsed.getPath();
      if (srcPath.equals("/")) srcPath = "/ ";
      String urlPath = urlParsed.getPath();
      if (urlPath.equals("/")) urlPath = "/ ";

      String[] srcsplit = srcPath.split("/");
      String[] urlsplit = urlPath.split("/");
      for (int i = 0; i < srcsplit.length - 1; ++i) {
        if (!srcsplit[i].equals(urlsplit[i])) return false;
      }
      String lastpathpart = srcsplit[srcsplit.length - 1];
      if (!lastpathpart.contains(".")) {
        if (!lastpathpart.equals(urlsplit[srcsplit.length - 1])) return false;
      }
      return true;
    } catch (Throwable t) {
      return false;
    }
  }

//  public static boolean isDeeper(String source, String url) {
//    if (source == null) return true;
//    if(source.startsWith(url)) return true;
//    String srcHost = getHost(source);
//    String urlHost = getHost(url);
//    if (!srcHost.equalsIgnoreCase(urlHost)) return false;
//
//    String s1 = source.substring(source.indexOf(srcHost) + srcHost.length());
//    String s2 = url.substring(url.indexOf(urlHost) + urlHost.length());
//
//  }

  public static String getHost(String url) {
    if (url == null) return null;
    return getPart(url, ParsedURL.Part.HOST);
  }

  public static String getDomainNaive(String url) {
    if (url == null) return null;

    String cc = "";

    String host = getPart(url, ParsedURL.Part.HOST);
    String withoutCCTld;
    Matcher ccMatcher = REGEX_COUNTRY_TLD.matcher(host);
    if (ccMatcher.find()) {
      cc = "." + ccMatcher.group(1);
      withoutCCTld = ccMatcher.replaceAll("");
    } else {
      withoutCCTld = host;
    }
//    if (withoutCCTld.indexOf(".") == -1) return withoutCCTld + cc;

    Matcher domainMatcher = REGEX_NAIVE_DOMAIN.matcher(withoutCCTld);
    if (domainMatcher.find()) {
      String domain = domainMatcher.group(1);
      String tlc = "." + domainMatcher.group(2);
      int lastdot = domain.lastIndexOf(".");
      if (lastdot > -1) {
        domain = domain.substring(lastdot + 1, domain.length());
      }
      return domain + tlc + cc;
    } else {
      String domain = withoutCCTld;
      int lastdot = domain.lastIndexOf(".");
      if (lastdot > -1) {
        domain = domain.substring(lastdot + 1, domain.length());
      }
      return domain + cc;
    }
  }

  private static String getPart(String url, ParsedURL.Part part) {
    try {
      ParsedURL u = URLParser.parse(url);
      return u.getString(part);
    } catch (MalformedURLException e) {
      return null;
    }
  }

  public static String getProtocol(String url) {
    if (url == null) return null;
    return getPart(url, ParsedURL.Part.PROTOCOL);
  }

  public static String getFullProtocol(String url) {
    if (url == null) return null;
    return getPart(url, ParsedURL.Part.HOST) + "://";
  }

  public static String getPath(String url) {
    if (url == null) return null;
    return getPart(url, ParsedURL.Part.PATH);
  }

  public static String getQueryString(String url) {
    if (url == null) return null;
    return getPart(url, ParsedURL.Part.QUERY);
  }

  // note: if there are multiple params with same name, only the last is retained

  public static Map<String, String> getQueryParameterMap(String url) {
    try {
      ParsedURL u = URLParser.parse(url);
      return getQueryParameterMap(u);
    } catch (MalformedURLException e) {
      System.out.println("Malformed url:" + url);
      e.printStackTrace();
      return null;
    }
  }

  // note: if there are multiple params with same name, only the last is retained

  public static Map<String, String> getQueryParameterMap(ParsedURL url) {
    String query = url.getQuery();
    if (query == null) return Collections.EMPTY_MAP;
    Map<String, String> params = new HashMap<String, String>();
    String[] split = query.split("&");
    for (String s : split) {
      int idx = s.indexOf("=");
      if (idx == -1) {
        params.put(s, null);
      } else {
        params.put(s.substring(0, idx), s.substring(idx + 1, s.length()));
      }
    }
    return params;
  }

  public static String makeAbsolute(ParsedURL baseurl, String spec) {
    return makeAbsolute(baseurl, spec, true);
  }

  public static String makeAbsolute(ParsedURL baseurl, String spec, boolean compat) {
    if (baseurl == null) return spec;
    if (spec == null) return baseurl.toString();
    spec = spec.trim().replace(" ", "+");
    if (spec.matches("^[a-z]+:.*")) return spec;

    ParsedURL base = baseurl.newInstance();
    ParsedURL parsedSpec = null;
    try {
      parsedSpec = URLParser.parse("http://www.flexile.org/" + spec);
    } catch (MalformedURLException e) {
      logger.info("Error parsing " + spec);
      e.printStackTrace();
      return spec;
    }

    String path = base.getPath();

    String specPath = parsedSpec.getPath();
    if (specPath == null) specPath = "/";
    specPath = specPath.substring(1);
    String specRef = parsedSpec.getRef();
    String specQuery = parsedSpec.getQuery();

    if (specPath.startsWith("/")) {
      base.set(ParsedURL.Part.PATH, specPath);
    } else {
      if (path == null || path.length() == 0) path = "/";

      if (specPath.length() > 0) {
        StringBuilder sb = new StringBuilder();
        sb.append(path);
        int lastslash = path.lastIndexOf("/");
        if (lastslash == -1) throw new IllegalStateException("Path should always have a slash");
        sb.delete(lastslash + 1, sb.length());
        sb.insert(lastslash + 1, specPath);
        String result = sb.toString();
        if (compat || !result.startsWith("/../")) result = canonicalizePath(result);
        base.set(ParsedURL.Part.PATH, result);
      }
    }

    if (specRef != null) {
      base.set(ParsedURL.Part.REF, specRef);
    } else {
      base.remove(ParsedURL.Part.REF);
    }
    if (specQuery != null) {
      base.set(ParsedURL.Part.QUERY, specQuery);
    } else {
      base.remove(ParsedURL.Part.QUERY);
    }
    return base.toString();
  }

  public static String makeAbsoluteURL(String context, String spec) {
    return makeAbsoluteURL(context, spec, true);
  }


  public static String makeAbsoluteURL(String context, String spec, boolean compat) {
    if (context == null) return spec;
    if (spec == null) return null;

    try {
      ParsedURL base = URLParser.parse(context);
      return makeAbsolute(base, spec, compat);
    } catch (MalformedURLException e) {
    }
    return spec;
//    try {
//      URL url = new URL(new URL(context), spec);
//      return url.toString();
//    } catch (MalformedURLException e) {
//    }
//    return spec;
  }

  /**
   * Apache Licensed - from Harmony project
   * Canonicalize the path, i.e. remove ".." and "." occurences.
   *
   * @param path the path to be canonicalized
   * @return the canonicalized path
   */
  public static String canonicalizePath(String path) {
    int dirIndex;
    while ((dirIndex = path.indexOf("/./")) >= 0) { //$NON-NLS-1$
      path = path.substring(0, dirIndex + 1)
          + path.substring(dirIndex + 3);
    }

    if (path.endsWith("/.")) { //$NON-NLS-1$
      path = path.substring(0, path.length() - 1);
    }

    while ((dirIndex = path.indexOf("/../")) >= 0) { //$NON-NLS-1$
      if (dirIndex != 0) {
        path = path.substring(0, path
            .lastIndexOf('/', dirIndex - 1))
            + path.substring(dirIndex + 3);
      } else {
        path = path.substring(dirIndex + 3);
      }
    }

    if (path.endsWith("/..") && path.length() > 3) { //$NON-NLS-1$
      path = path.substring(0, path.lastIndexOf('/',
          path.length() - 4) + 1);
    }
    return path;
  }

  public static String safeDecode(String value) {
    // HACK: workaround for urls that have invalidly encoded urls
    value = value.replaceAll("%([^A-Za-z0-9]+)", "%");
    value = decode(value);
    return value;
  }

  public static String decode(String url) {
    try {
      return URLDecoder.decode(url, "UTF-8");
    } catch (UnsupportedEncodingException e) {
      // won't happen because UTF-8 is good
      return null;
    }
  }

  public static String encode(String url) {
    try {
      return URLEncoder.encode(url, "UTF-8");
    } catch (UnsupportedEncodingException e) {
      // won't happen because UTF-8 is good
      return null;
    }
  }

  public static String httpGet(String urlstr) throws IOException {
    java.net.URL url = new java.net.URL(urlstr);
    java.net.HttpURLConnection conn = openConnection(url);
    BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
    StringBuilder sb = readFully(conn);
    conn.disconnect();
    return sb.toString();
  }

  public static String httpGet302(String urlstr) throws IOException {
    java.net.URL url = new java.net.URL(urlstr);
    java.net.HttpURLConnection conn = openConnection(url);
    conn.setInstanceFollowRedirects(false);
    StringBuilder sb = readFully(conn);
    conn.disconnect();
    return conn.getHeaderField("Location");
  }

  private static StringBuilder readFully(HttpURLConnection conn) throws IOException {
    BufferedReader in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
    StringBuilder sb = new StringBuilder();
    String s = null;
    while ((s = in.readLine()) != null) {
      sb.append(s).append("\n");
    }
    return sb;
  }


  public static String httpPost(String url, String body) throws IOException {
    return httpPost(url, body, Collections.EMPTY_MAP);
  }

  public static String httpPost(String url, String body, Map<String, String> headers) throws IOException {
    java.net.HttpURLConnection conn;
    conn = openConnection(new URL(url));
    for (String k : headers.keySet()) {
      String v = headers.get(k);
      conn.setRequestProperty(k, v);
    }

    conn.setDoOutput(true);
    java.io.OutputStreamWriter out = new java.io.OutputStreamWriter(conn.getOutputStream());
    out.write(body);
    out.flush();
    out.close();
    StringBuilder sb = readFully(conn);
    conn.disconnect();
    return sb.toString();
  }

  public static String httpPost302(String url, String body, Map<String, String> headers) throws IOException {
    java.net.HttpURLConnection conn;
    conn = openConnection(new URL(url));
    conn.setInstanceFollowRedirects(false);
    for (String k : headers.keySet()) {
      String v = headers.get(k);
      conn.setRequestProperty(k, v);
    }

    conn.setDoOutput(true);
    java.io.OutputStreamWriter out = new java.io.OutputStreamWriter(conn.getOutputStream());
    out.write(body);
    out.flush();
    out.close();
    StringBuilder sb = readFully(conn);
    conn.disconnect();
    return conn.getHeaderField("Location");
  }


  public static void download(String urlstr, String outputfile, boolean append) throws IOException {
//    System.out.println("Downloading " + urlstr + " to " + outputfile);
    java.net.URL url = new java.net.URL(urlstr);
    java.net.HttpURLConnection conn = openConnection(url);
    java.io.InputStream in = conn.getInputStream();
    java.io.OutputStream out = new java.io.FileOutputStream(outputfile, append);
    byte[] b = new byte[4096];
    int read = 0;
    while ((read = in.read(b)) != -1) {
      out.write(b, 0, read);
    }
    out.close();
    conn.disconnect();
  }

  public static java.net.HttpURLConnection openConnection(java.net.URL url) throws java.io.IOException {
    java.net.HttpURLConnection conn = (java.net.HttpURLConnection) url.openConnection();
    conn.setInstanceFollowRedirects(true);
    conn.setConnectTimeout(CONNECT_TIMEOUT_MILLISECONDS);
    conn.setReadTimeout(READ_TIMEOUT_MILLISECONDS);
    conn.setRequestProperty("User-Agent", "Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0.13) Gecko/2009080315 Ubuntu/9.04 (jaunty) Firefox/3.0.13");
    return conn;
  }
}
